## mingw-w64-webview-0.12.0-3.src.tar.zst

=== compatibility/CMakeLists.txt ===
if(WEBVIEW_USE_COMPAT_MINGW)
    add_subdirectory(mingw)
endif()
